(	
global MTS_Rollout
	try (destroydialog MTS_Rollout)catch()
	
	local traceSetObj = undefined
	struct nfo (obj,name)
	local objInfo = undefined
	local nameArray = #()
	local objArray = #()
	local includeOn = undefined
	
	
	fn collectObjects = (
        local currentSelection = selection as array
        for o in geometry do (
          --  if finditem currentSelection o == 0 do (  -- hide selctedt objects, but doesn't let you use the CLear function...
                objInfo = nfo obj:o name:o.name
                append nameArray objInfo.name
				append objArray objInfo.obj
          --  )
        )
    )
    collectObjects()

	fn getSelectionSetNames = (
		local selectionSetNames = #()
		for i = 1 to selectionSets.count do (
			append selectionSetNames selectionSets[i].name
		)
		sort selectionSetNames
		insertItem "Select..." selectionSetNames 1 -- Ensure "Select..." is at the top after sorting
		return selectionSetNames
	)


	fn getNodesByName setName = (
		local nodes = #()
		-- Attempt to find the selection set by name and collect its members
		if (selectionSets[setName] != undefined) then (
			local theSet = selectionSets[setName]
			for i = 1 to theSet.count do (
				append nodes theSet[i]
			)
		)
		return nodes
	)
	

   fn updateSelectionSetsDropdown = (
        MTS_Rollout.selectionSets_ddl.items = getSelectionSetNames() -- Populate dropdown with selection set names
    )	
	
	
	rollout MTS_Rollout "MultiTraceSets"
(
	button 'btn1' "Add" pos:[10,242] width: 240 height: 40 align:#center tooltip: "This script edits the selected objects' reflection/refraction trace sets. Select a target object in the scene; choose which objects to exclude/include from the menu above and run."
	button 'btn2' "Clear" pos: [10,287] width: 100 height: 20 align:#center tooltip: "Clear the target objects' trace sets."
	button 'btn3' "Refresh" pos:[150,10] width: 100 height:20
	multilistbox 'lst1' "Scene Objects:" pos:[10,20] width: 240 items: nameArray
	dropdownlist selectionSets_ddl "Selection Sets" pos:[10,180] width:240 height:20 -- Added dropdown list for selection sets
	checkbox 'chk1' "Reflection" pos: [10,222] checked: false
	checkbox 'chk2' "Refraction" pos: [90,222] checked: false
	checkbox 'chk3' "Include?" pos: [170,222] checked: false
	label 'edt4' " Chaos 3D Support Team" pos:[120,285]
	hyperlink 'link1' "V-Ray Knowledge Base" pos:[140,296] color: (color 39 200 255) hovercolor: (color 39 140 255) address:"https://support.chaos.com/hc/en-us/sections/10633063984273-V-Ray-Knowledge-Base-"
	

	on MTS_Rollout open do (
		updateSelectionSetsDropdown() -- Populate dropdown with selection sets on rollout open
	)

	on selectionSets_ddl selected index do (
		if index == 1 then ( -- "Select..." option
			lst1.selection = #() -- Deselect everything in the listbox
		) else if index > 1 do (
			local selectedSetName = selectionSets_ddl.items[index]
			local setMembers = getNodesByName selectedSetName
			local validSelectionIndices = for obj in setMembers where findItem nameArray obj.name > 0 collect findItem nameArray obj.name
			lst1.selection = validSelectionIndices
		)
		
	)
		
	
	
	fn isVRayCurrent = matchPattern (renderers.current as string) pattern:"*V_RAY*"

	fn clearTraceSets = (
		for each in selection do (
		traceSetObj = vrayAddTraceSets each
		traceSetObj.reflect_exclude=#()
		traceSetObj.refract_exclude=#()
		traceSetObj.reflect_exclude_type=0
		traceSetObj.refract_exclude_type=0
		)
	)
	
	fn EditTraceSets = (
		if selection.count > 0 then (
			for each in selection do (
			
			--skip non-geometry in current selection
			if (superClassOf each == GeometryClass) do (
				
				traceSetObj = vrayAddTraceSets each
				if chk3.checked == true then traceSetObj.reflect_exclude_type=1 else traceSetObj.reflect_exclude_type=0
				if chk3.checked == true then traceSetObj.refract_exclude_type=1 else traceSetObj.refract_exclude_type=0
	
						
					for i in lst1.selection do 
						(

							if chk1.checked == true do (
								try(
									append traceSetObj.reflect_exclude objArray[i]
									traceSetObj.reflect_exclude = makeUniqueArray (traceSetObj.reflect_exclude as array)
								) catch ( -- catch dependency loop
									print ("Unable to add " + (nameArray[i] as string) + " to reflection exclude for " + (each.name as string) + ". Probably a dependency loop. caused by " + (each.name as string) + " already being excluded from " + (nameArray[i] as string) )
								) 
									
							)
							if chk2.checked ==true do (
								try(
									traceSetObj.refract_exclude = makeUniqueArray (traceSetObj.refract_exclude as array)
									append traceSetObj.refract_exclude objArray[i]
								) catch ( -- catch dependency loop
									print ("Unable to add " + (nameArray[i] as string) + " to refraction exclude for " + (each.name as string) + ". Probably a dependency loop. caused by " + (each.name as string) + " already being excluded from " + (nameArray[i] as string) )
								)
							)

						)
					)
				)
			)
			else return messageBox "Select target object/s." title: "Error!"
	)
	
	on btn1 pressed do 
	(
		if isVRayCurrent() == true then print "Okay." else return messageBox "V-Ray is not set to current renderer!" title: "Error!"
		if chk2.checked == false and chk1.checked == false do return messageBox "Choose trace set to add (reflection/refraction)." title: "Error!"
		clearTraceSets()
		EditTraceSets()
	)
	on btn2 pressed do (
		clearTraceSets()
	)
	on btn3 pressed do (
		nameArray = #()
		objArray = #()
		lst1.items = #()
		collectObjects()
		lst1.items =  makeUniqueArray nameArray
	)
)	
createDialog MTS_Rollout 260 310
)